Libargus API Libargus Camera API

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
DeFog.h
Go to the documentation of this file.
1 /*
2 * Copyright (c) 2016-2017, NVIDIA CORPORATION. All rights reserved.
3 *
4 * Redistribution and use in source and binary forms, with or without
5 * modification, are permitted provided that the following conditions
6 * are met:
7 * * Redistributions of source code must retain the above copyright
8 * notice, this list of conditions and the following disclaimer.
9 * * Redistributions in binary form must reproduce the above copyright
10 * notice, this list of conditions and the following disclaimer in the
11 * documentation and/or other materials provided with the distribution.
12 * * Neither the name of NVIDIA CORPORATION nor the names of its
13 * contributors may be used to endorse or promote products derived
14 * from this software without specific prior written permission.
15 *
16 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS ``AS IS'' AND ANY
17 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
19 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
20 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
21 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
22 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
23 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
24 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
25 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
26 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
27 */
28
29 /**
30 * @file
31 * <b>Libargus Extension: DeFog API</b>
32 *
33 * @b Description: This file defines the DeFog extension.
34 */
35
36 #ifndef _ARGUS_DE_FOG_H
37 #define _ARGUS_DE_FOG_H
38
39 namespace Argus
40 {
41
42 /**
43 * Adds internal de-fog post-processing algorithms. It introduces one new interface:
44 * - IDeFogSettings; used to enable de-fog for a Request.
45 *
46 * @defgroup ArgusExtDeFog Ext::DeFog
47 * @ingroup ArgusExtensions
48 */
49 DEFINE_UUID(ExtensionName, EXT_DE_FOG, 9cf05bd0,1d99,4be8,8732,75,99,55,7f,ed,3a);
50 namespace Ext
51 {
52
53 /**
54 * @class IDeFogSettings
55 *
56 * Interface to de-fog settings.
57 *
58 * @ingroup ArgusRequest ArgusExtDeFog
59 */
60 DEFINE_UUID(InterfaceID, IID_DE_FOG_SETTINGS, 9cf05bd1,1d99,4be8,8732,75,99,55,7f,ed,3a);
61 class IDeFogSettings : public Interface
62 {
63 public:
64 static const InterfaceID& id() { return IID_DE_FOG_SETTINGS; }
65
66 /**
67 * Enables or disables de-fog.
68 * @param[in] enable whether or not de-fog is enabled.
69 */
70 virtual void setDeFogEnable(bool enable) = 0;
71
72 /**
73 * @returns whether or not de-fog is enabled.
74 */
75 virtual bool getDeFogEnable() const = 0;
76
77 /**
78 * Sets the amount of fog to be removed. Range 0.0 - 1.0 (none - all).
79 * @param[in] amount amount of fog to remove.
80 */
81 virtual Status setDeFogAmount(float amount) = 0;
82
83 /**
84 * @returns the amount of fog to remove.
85 */
86 virtual float getDeFogAmount() const = 0;
87
88 /**
89 * Set the quality of the effect, lower quality results in lower execution time.
90 * Range 0.0 - 1.0 (low quality - high quality).
91 * @param[in] quality effect quality.
92 */
93 virtual Status setDeFogQuality(float quality) = 0;
94
95 /**
96 * @returns the effect quality.
97 */
98 virtual float getDeFogQuality() const = 0;
99
100 protected:
101 ~IDeFogSettings() {}
102 };
103
104 } // namespace Ext
105
106 } // namespace Argus
107
108 #endif // _ARGUS_DE_FOG_H